--[[
implementation of the RC5 cipher in Lua5.1
Licensed under the GNU GPLv3 license

03/28/2022
Sean Smith
sean@spacealien.xyz

todo:
move setup, encrypt, and decrypt to functions
use file io to encrypt files

]]

local inspect = require 'inspect'
local bit = require 'bit'

local insert, concat, modf, tostring, char = table.insert, table.concat, math.modf, tostring, string.char

local w=64 --length of a word in bits
local u=8 --length of a word in bytes
local r=24
--local key="globglogabgalab1"
local key="0000000000000000"
local b=16 --length of the key in bytes
--local c=2 (with globglogabgalab1 as the key c should =2)
local t = 2 * (r + 1) --the number of round subkeys required
--convert the key into an array of ints (starts at K[1]
local K = {string.byte(key, 1, -1)}
local L = {}
--length of the key in words
c = math.ceil(math.max(b, 1) / u)
L = K

--magic constants for 64bit word size (hex)
local P = 0xb7e151628aed2a6b
local Q = 0x9e3779b97f4a7c15

local S = {}
S[0] = P	--initialize the S array
for i = 1, t do
	S[i] = S[i-1] + Q
	--print("S[i]")
	--print(S[i])
	--print(i)
	i = i + 1
end

--mixing in the secret key
local i, j, A, B = 1, 1, 0, 0	--j flops between 1 and 2
for f = 1, 3 * math.max(t,c) do
	--print(f)
	print("heres A")
	print(inspect(A))
	print("heres B")
	print(inspect(B))
	--print("heres L[]")
	--print(inspect(L))
	--print("heres S[]")
	--print(inspect(S))
	--print("heres j")
	--print(j)
	--print("heres i")
	--print(i)
	S[i] = bit.rol((S[i] + A + B), 3)
	A = S[i]
	L[j] = bit.rol((L[j] + A + B), (A + B))
	B = L[j]
	i = (i % t) + 1
	j = (j % c) + 1
	--[[
	due to lua prefering arrays starting at 1 instead 
	of zero, you need to add 1 so its filling array 1 and 
	2 instead of 0 and 1
	]]
end

--8 bytes to be encrypted
A = 12345678
B = 12345678
print("Plaintext A & B")
print(A)
print(B)

--encrypt
--assume that the input block is given in two w-bit registers 
--A and B
--the A and B found in the setup have been loaded into the S
--array and can now be filled with words of plaintext
A = A + S[1]
B = B + S[2]
for i = 1, r do
	A = bit.rol((bit.bxor(A, B)), B) + S[2*i]
	B = bit.rol((bit.bxor(B, A)), A) + S[2*i + 1]
end
print("Encrypted output A & B")
print(A)
print(B)

--decrypt
for i = r, 1, -1 do
	B = bit.bxor(bit.ror((B - S[2*i+1]), A), A)
	A = bit.bxor(bit.ror((A - S[2*i]), B), B)
end
B = B - S[2]
A = A - S[1]
print("Decrypted output A & B")
print(A)
print(B)
